## prime-phylo 1.0.11

=== CMakeLists.txt ===
################################################
# Level: trunk/CMakeLists.txt
################################################

cmake_minimum_required(VERSION 2.8)
project(prime-phylo CXX)

SET(CMAKE_BUILD_TYPE Debug)

set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")
set(CPACK_PACKAGE_VERSION_PATCH "11")

set(PACKAGE_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PROJECT_NAME}-${PACKAGE_VERSION})
set(CPACK_GENERATOR RPM;DEB)

set(tmp_man_pages_dir  ${CMAKE_BINARY_DIR}/tmp_manpages)

set(TESTDATA_DIR "${CMAKE_SOURCE_DIR}/example_data/testdata_for_automatic_tests")
set(date_for_man_pages "13 Mar, 2012")

include(${CMAKE_SOURCE_DIR}/cmake/macro.cmake)

# is these packages dependencies on Ubuntu 11.10?
# libplot2c2
# libboost-mpi1.46.1 
# libboost-serialization1.46.1

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libxml2 (>= 2.6.16 ), liblapack3gf (>= 3.0.0),  libatlas3gf-base, libgfortran3, libopenmpi1.3, libquadmath0, libstdc++6, zlib1g")

# how can we control the filename of the produced DEBIAN package?
# CPACK_DEBIAN_PACKAGE_VERSION CPACK_DEBIAN_PACKAGE_NAME don't seem to change the filename.
#




# Some of the dependencies in CPACK_DEBIAN_PACKAGE_DEPENDS were found by running this command:
# for i in `ls /tmp/primeinstall/bin/*`; do ldd $i; done | awk '{print $3;}' | xargs -i dpkg -S {}

set(CPACK_SOURCE_GENERATOR TGZ;ZIP)
# set(CPACK_RPM_PACKAGE_ARCHITECTURE "i386")
set(CPACK_PACKAGE_CONTACT "erik.sjolund@sbc.su.se") 
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "prime-phylo is a software package for probabilistic integrated models of evolution. The homepage is located at http://prime.sbc.su.se/. It is written in the programming language C++.")
set(CPACK_PACKAGE_VENDOR "")


#configure_file(debian/control.cmake @CMAKE_BINARY_DIR@/debian/control @ONLY)

# A tip that could be useful if we want to include generated files into the target "package_source":
# How to include a generated file into the target "package_source": A tip from
# http://www.cmake.org/pipermail/cmake/2011-January/041850.html

set(CPACK_SOURCE_IGNORE_FILES "\\\\.svn/" "/deprecated_files/" "/docbook/" "/Scripts/" "/primeOrthology/" "/.cdtproject" "/excluded_from_release/" "/example_data/" "/.cproject" "/.project") 
include(CPack)

#add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-${PACKAGE_VERSION}.tar.gz)
#  COMMAND make package_source
#  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
#)

#add_custom_target(ports 
#  COMMAND  
#  DEPEND ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-${PACKAGE_VERSION}.tar.gz
#  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
#)

#file(<MD5|SHA1|SHA224|SHA256|SHA384|SHA512> filename variable)

macro(my_find_program progname)
  find_program(${progname}_EXECUTABLE ${progname})
  if(NOT ${progname}_EXECUTABLE)
    message(FATAL_ERROR  "${progname} not found" )
  endif()
endmacro(my_find_program)

#my_find_program(xsltproc)
my_find_program(gengetopt)

find_program(svnversion_EXECUTABLE svnversion)
if(svnversion_EXECUTABLE)
  execute_process( COMMAND ${svnversion_EXECUTABLE} -n ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE SVN_VERSION_OUTPUT)
  if(SVN_VERSION_OUTPUT MATCHES "exported")
    set(SVN_REVISION UNKNOWN)
  else()
    set(SVN_REVISION "${SVN_VERSION_OUTPUT}")
  endif()
else()
    set(SVN_REVISION UNKNOWN)
endif()

if(SVN_REVISION)
  set(SVN_REVISION_STRING "( subversion revision: ${SVN_REVISION} )")
endif()

set(VERSION_FOR_HELP_OUTPUT "${PACKAGE_VERSION} ${SVN_REVISION_STRING}")

option(BUILD_DOCUMENTATION "build Docbook and Doxygen html documentation" OFF )

if(EXISTS ${CMAKE_SOURCE_DIR}/example_data)
  enable_testing()
endif()

add_subdirectory(src/cxx)
#add_subdirectory(src/docbook)
add_subdirectory(src/perl)

#configure_file(packaging/macports/Portfile.cmake  @CMAKE_BINARY_DIR@/packaging/macports/Portfile.without_checksums @ONLY)

#file(MAKE_DIRECTORY @CMAKE_BINARY_DIR@/packaging/macports/ports/science/${PROJECT_NAME})
#configure_file(packaging/macports/fix_checksums_and_publish_on_web2.sh.cmake @CMAKE_BINARY_DIR@/packaging/macports/fix_checksums_and_publish_on_web2.sh @ONLY)

file(GLOB manpages ${tmp_man_pages_dir}/[^.]*[^~])
foreach(i ${manpages})
  install(FILES ${i} DESTINATION share/man/man1)
endforeach()


if(EXISTS @CMAKE_SOURCE_DIR@/excluded_from_release)
  set(BUILD_FOR_DEBIAN_OR_UBUNTU "ubuntu" CACHE STRING "The command ${CMAKE_BINARY_DIR}/build_debian_package.sh will build for distribution type (debian or ubuntu)")
  set(BUILD_FOR_DEBIAN_OR_UBUNTU_RELEASE "precise" CACHE STRING "The command ${CMAKE_BINARY_DIR}/build_debian_package.sh will build for this debian/ubuntu release")
  set(BUILD_FOR_DEBIAN_OR_UBUNTU_ARCH "amd64" CACHE STRING "The command ${CMAKE_BINARY_DIR}/build_debian_package.sh will build for this debian/ubuntu arch")
  set(CPU_COUNT_FOR_BUILD_IN_VAGRANT "1" CACHE STRING "The command ${CMAKE_BINARY_DIR}/build_debian_package.sh will use this number of CPUs when building in Vagrant")
  if(@BUILD_FOR_DEBIAN_OR_UBUNTU_ARCH@ STREQUAL "amd64")
    set(vagrant_box "precise64")
  else()
    set(vagrant_box "precise32")
  endif()
  set(vagrant_dir "${CMAKE_BINARY_DIR}/vagrant_debian_build")
  configure_file(excluded_from_release/packaging/debian/build_debian_package.sh.cmake ${CMAKE_BINARY_DIR}/build_debian_package.sh @ONLY)
  file(MAKE_DIRECTORY "${vagrantdir}")
  configure_file(excluded_from_release/packaging/debian/Vagrantfile.cmake "${vagrant_dir}/Vagrantfile" @ONLY)
  configure_file(excluded_from_release/packaging/debian/provision.sh.cmake "${vagrant_dir}/provision.sh" @ONLY)
endif()

=== src/cxx/CMakeLists.txt ===
################################################
# Level: trunk/src/cxx/CMakeLists.txt
################################################

enable_language(Fortran)
enable_language(C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/")

find_package(BLAS REQUIRED)
message("hittade ${BLAS_LIBRARIES}")

find_package(LAPACK REQUIRED)

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)
#find_package(PNG  REQUIRED)
#find_package(X11  REQUIRED)
find_package(MPI  REQUIRED)

file(MAKE_DIRECTORY ${tmp_man_pages_dir})





If (NOT MPI_C_INCLUDE_PATH)
 # cmake doesn't find mpi from openmpi it seems.
 # We search for it ourselves
  find_path(MY_INC_DIR mpi.h PATH_SUFFIXES usr/lib/openmpi/include include/openmpi)
  if (MY_INC_DIR) 
    set(MPI_C_INCLUDE_PATH ${MY_INC_DIR})
  elseif()
    message(FATAL_ERROR "In prime-trunk/src/cxx/CMakeLists.txt culd not find mpi.h")
  endif()
endif()


if (NOT MPI_C_LIBRARIES)
  message(fatal_error "Could not find mpi C libraries")
endif()


if (NOT MPI_CXX_LIBRARIES)
  message(fatal_error "Could not find mpi CXX libraries")
endif()



if (NOT MPI_CXX_INCLUDE_PATH)
 # cmake doesn't find mpi from openmpi it seems.
 # We search for it ourselves

                                                  #lib/openmpi/include/openmpi/ompi/mpi/cxx
  find_path(MY_INC_CXX_DIR mpicxx.h PATH_SUFFIXES usr/lib/openmpi/include/openmpi/ompi/mpi/cxx   include/openmpi/openmpi/ompi/mpi/cxx)
  if (MY_INC_CXX_DIR) 
    set(MPI_CXX_INCLUDE_PATH ${MY_INC_CXX_DIR})
  elseif()
    message(FATAL_ERROR "In prime-trunk/src/cxx/CMakeLists.txt culd not find mpicxx.h")
  endif()
endif()

#    message(FATAL_ERROR "rwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww ${MPI_CXX_INCLUDE_PATH}")

#include_directories( /usr/lib/openmpi/include/openmpi/ompi/mpi/cxx )
#include_directories( /usr/lib/openmpi/include )


include_directories(${MPI_C_INCLUDE_PATH})
include_directories(${MPI_CXX_INCLUDE_PATH})
include_directories(${MPI_CXX_INCLUDE_PATH}/ompi/mpi/cxx)

set(primexml_namespace http://prime.sbc.su.se/primexml/1)

if(NOT prime_dynamic) 
  set(Boost_USE_STATIC_LIBS   ON)

else()
set(Boost_USE_STATIC_RUNTIME OFF)
  set(Boost_USE_STATIC_LIBS   OFF)

endif()

set(Boost_USE_MULTITHREADED ON)

#set(Boost_ADDITIONAL_VERSIONS "1.46.1.1" "1.46")
#find_package( Boost 1..0 COMPONENTS date_time filesystem system ... )




find_package(Boost 1.40.0 COMPONENTS mpi serialization REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})
#message("Boost inc dir ${Boost_INCLUDE_DIRS}")


find_package(LibXml2 REQUIRED)
include_directories( ${LIBXML2_INCLUDE_DIR} )
add_definitions( ${LIBXML2_DEFINITIONS} )


set(CMAKE_INCLUDE_CURRENT_DIR ON)





#============================================================================
# DOCUMENTATION AND DOXYGEN
#============================================================================

if(BUILD_DOCUMENTATION)
  find_package(Doxygen REQUIRED)
  file(GLOB_RECURSE sourcefiles "*.cc"  "*.c" "*.hh" "*.h" )
  set(doxygenconf ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
  set(doxygenoutputdir ${CMAKE_CURRENT_BINARY_DIR}/doxygen)
  configure_file( Doxyfile.cmake ${doxygenconf} @ONLY)
  add_custom_command(OUTPUT "${doxygenoutputdir}/html/index.html"
    COMMAND ${DOXYGEN_EXECUTABLE} ${doxygenconf} 
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS ${FILES} ${doxygenconf}
  )
  add_custom_target(doxygen ALL DEPENDS "${doxygenoutputdir}/html/index.html")
  install(DIRECTORY ${doxygenoutputdir} DESTINATION share/doc/PrIME PATTERN ".svn" EXCLUDE )
endif()


#============================================================================
# INCLUDE DIRECTORIES
#============================================================================

include_directories( ${CMAKE_SOURCE_DIR}/src/cxx/libraries/prime )

# We include this directory e.g. for platform-dependent auto-generated includes
# placed in the build dir
include_directories( ${CMAKE_BINARY_DIR}/src/cxx/libraries/prime )

#include_directories( ${CMAKE_SOURCE_DIR}/src/cxx/libraries/sfile )
# actually sfile seems to be included like this: #include "sfile/sfile.h" 
# /Someone (Erik?)
#
# I think this is because '..../cxx/libraries' is set as an include directory,
# which by the way seems unnecessary.
# Right now you could also type, for instance, #include "prime/Tree.hh" and it would work.
# /Peter

include_directories( ${CMAKE_SOURCE_DIR}/src/cxx/libraries )


#============================================================================
# GENERAL BUILD FLAGS
# Examples when running cmake:
#   Default and debug flags:   "cmake -D CMAKE_BUILD_TYPE=Debug ..."
#   Default and release flags: "cmake -D CMAKE_BUILD_TYPE=Release ..."
#============================================================================

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wreorder -Wall -fexceptions")
if( ${CMAKE_CXX_COMPILER} MATCHES "icpc" )
    # Remove annoying Intel warnings.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd383 -wd869 -wd981")
endif( ${CMAKE_CXX_COMPILER} MATCHES "icpc" )
#set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g")
#set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -funroll-loops -DNDEBUG")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -fexceptions")
#set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
#set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")


#============================================================================
# PRIME BEHAVIOUR FLAGS
# Note: All of these should be made into settings within the source
#       code -- remember: defining behaviour with ifdefs is bad style!
# Important note: Default is specified with ON/OFF in option definition.
#                 Notify the other developers if you check in changes.
# Example when running cmake: "cmake -D ENABLE_MY_OPTION=ON ..."
#============================================================================

option(ENABLE_PERTURBED_NODE "Speeds up calculation of SubstitutionLike.
  This is meaningful when, in some iterations, parameters are perturbed that
  do not affect or only affects part of the tree. Note! When using this
  speed-up, all classes that perturb a Tree in som way MUST set
  Tree::perturbed_node properly, else SubstLike will not be correctly
  calculated!! Look at example code in EdgeRateMCMC_common or
  ReconciliationTimeMCMC. /bens
" ON)
option(ENABLE_PERTURBED_TREE "Speeds up calculation of SubstitutionLike.
  NOTE! Currently only works when the tree root and 'topology' not change
  between iterations.
" OFF)
option(ENABLE_ONLY_ONE_TIMESAMPLE "Is not really an optimization, but
  does  speed things up. 
" ON)
# joelgs: The following are now handled with enums in subclasses of
# EdgeWeightModel. Thank god. Default is in most cases option off.
# The first two have been merged into one since they mean the same thing.
#option(ENABLE_INCLUDE_ROOT_RATE "Enables separate perturbation of the two
#  edges going out from the root in EdgeRateMCMC_common. If not enabled,
#  only one of them will be perturbed. Don't enable simultaneously with
#  ENABLE_FIX_ROOT_EDGES_RATE. Note: Don't confuse with similarly named
#  ENABLE_ROOT_RATES.
#" OFF)
#option(ENABLE_INCLUDE_ROOT_RATES "Enables separate perturbation of the two
#  edges going out from the root in VarRateModel and EdgeWeightMCMC. If
#  not enabled, only one of them will be perturbed. Don't enable
#  simultaneously with ENABLE_FIX_ROOT_EDGES_RATE. Note: Don't confuse with
#  similarly named ENABLE_INCLUDE_ROOT_RATE.
#" OFF)
#option(ENABLE_FIX_ROOT_EDGES_RATE "Turns off perturbation of the edges
#  going out from the root in various models. Don't enable simultaneously
#  with ENABLE_INCLUDE_ROOT_RATE or ENABLE_INCLUDE_ROOT_RATES.
#" OFF)
option(ENABLE_USE_EMBEDDED_PARAMS "Perturbs the embedded parameters
  (currently only variance) of EdgeRateMCMC -- test to see if this improves
  convergence rate.
" OFF)


if(ENABLE_PERTURBED_NODE)
    add_definitions("-DPERTURBED_NODE")
endif()
if(ENABLE_PERTURBED_TREE)
    add_definitions("-DPERTURBED_TREE")
endif()
if(ENABLE_ONLY_ONE_TIMESAMPLE)
    add_definitions("-DONLY_ONE_TIMESAMPLE")
endif()
if(ENABLE_INCLUDE_ROOT_RATE)
    add_definitions("-DINCLUDE_ROOT_RATE")
endif()
if(ENABLE_INCLUDE_ROOT_RATES)
    add_definitions("-DINCLUDE_ROOT_RATES")
endif()
if(ENABLE_FIX_ROOT_EDGES_RATE)
    add_definitions("-DFIX_ROOT_EDGES_RATE")
endif()
if(ENABLE_USE_EMBEDDED_PARAMS)
    add_definitions("-DUSE_EMBEDDED_PARAMS")
endif()


#===========================================================================
# PRIME DEBUG FLAGS
# Note: NDEBUG, which turns off assertions etc., is enabled by default in
#       the release build.
# Important note: Default is specified with ON/OFF in option definition.
#                 Notify the other developers if you check in changes.
# Example when running cmake: "cmake -D ENABLE_MY_OPTION=ON ..."
#===========================================================================

option(ENABLE_DEBUG_BRANCHSWAPPING    "Activate debugging of BranchSwapping."                  OFF)
option(ENABLE_DEBUG_DP                "Activate debugging of GuestTreeModel."                  OFF)
option(ENABLE_DEBUG_SAMPLING          "Activate debugging of ReconciliationSampler."           OFF)
option(ENABLE_DEBUG_SHOW_CONSTRUCTORS "Write constructor names as they are invoked."           OFF)
option(ENABLE_SHOW_LAMBDA             "?"                                                      OFF)
option(ENABLE_DEBUG_SHOWPROBS         "Output a likelihood for all models."                    OFF)
option(ENABLE_ABORT_ERRORS            "Stops when AnError is created, before throwing."        OFF)
option(ENABLE_YYDEBUG_EQ_1            "This is for NHXparse.y."                                OFF)
option(ENABLE_TIME_DEBUGGING          "?"                                                      OFF)
option(ENABLE_DEBUG_PARAMS            "Prints out all parameters when params4os() is called."  OFF)
option(ENABLE_DISTR_DEBUG             "For PVM-related debugging."                             OFF)
option(ENABLE_DEBUG_PROPOSAL          "Used in SimpleMCMC."                                    OFF)


if(ENABLE_DEBUG_BRANCHSWAPPING)
    add_definitions("-DDEBUG_BRANCHSWAPPING")
endif()
if(ENABLE_DEBUG_DP)
    add_definitions("-DDEBUG_DP")
endif()
if(ENABLE_DEBUG_SAMPLING)
    add_definitions("-DDEBUG_SAMPLING")
endif()
if(ENABLE_DEBUG_SHOW_CONSTRUCTORS)
    add_definitions("-DDEBUG_SHOW_CONSTRUCTORS")
endif()
if(ENABLE_SHOW_LAMBDA)
    add_definitions("-DSHOW_LAMBDA")
endif()
if(ENABLE_DEBUG_SHOWPROBS)
    add_definitions("-DDEBUG_SHOWPROBS")
endif()
if(ENABLE_ABORT_ERRORS)
    add_definitions("-DABORT_ERRORS")
endif()
if(ENABLE_YYDEBUG_EQ_1)
    add_definitions("-DYYDEBUG=1")
endif()
if(ENABLE_TIME_DEBUGGING)
    add_definitions("-DTIME_DEBUGGING")
endif()
if(ENABLE_DEBUG_PARAMS)
    add_definitions("-DDEBUG_PARAMS")
endif()
if(ENABLE_DISTR_DEBUG)
    add_definitions("-DDISTR_DEBUG")
endif()
if(ENABLE_DEBUG_PROPOSAL)
    add_definitions("-DDEBUG_PROPOSAL")
endif()


#===========================================================================
# PLATFORM OPTIMIZATION FLAGS
# Note: Off by default.
# Example when running cmake: "cmake -D ENABLE_MY_OPTIMIZATION=ON ..."
#===========================================================================

if(CMAKE_COMPILER_IS_GNUCXX)
    if(OPTIMIZE_FOR_FERLIN)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=core2 -mfpmath=sse")
    endif(OPTIMIZE_FOR_FERLIN)
    if(OPTIMIZE_FOR_DELL_DIM_5000)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=prescott -mfpmath=sse")
    endif(OPTIMIZE_FOR_DELL_DIM_5000)
endif(CMAKE_COMPILER_IS_GNUCXX)

#============================================================================
# PROFILING
#============================================================================

list(APPEND CMAKE_BUILD_TYPES Profile)
set(CMAKE_C_FLAGS_PROFILE "-pg -g")
set(CMAKE_CXX_FLAGS_PROFILE "-pg -g")
set(CMAKE_EXE_LINKER_FLAGS_PROFILE "-pg")

=== src/perl/CMakeLists.txt ===
install(FILES mcmc_analysis DESTINATION bin PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

configure_file(mcmc_analysis.1.cmake ${tmp_man_pages_dir}/mcmc_analysis.1 @ONLY)

=== src/cxx/applications/mapdp/CMakeLists.txt ===
include(${CMAKE_SOURCE_DIR}/src/cxx/cmake-include.txt)

# mapdp/seq_ML_two_ways.cc:174: error: no matching function for call to 'beep::TreeIO::readBeepTree(bool&, bool, bool, bool&, int, int)'



add_executable(${programname_of_this_subdir}
seq_ML_two_ways.cc
${CMAKE_CURRENT_BINARY_DIR}/cmdline.c   ${CMAKE_CURRENT_BINARY_DIR}/cmdline.h 
)

target_link_libraries(${programname_of_this_subdir} prime-phylo)

install(TARGETS ${programname_of_this_subdir} DESTINATION bin)

=== src/cxx/applications/primeCT/CMakeLists.txt ===
include(${CMAKE_SOURCE_DIR}/src/cxx/cmake-include.txt)

if(Boost_FOUND)

find_library(tmp plot )
if(NOT tmp)
  message(FATAL_ERROR  "libplot not found" )
endif(NOT tmp )

add_executable(${programname_of_this_subdir}
primect.cc
ConsensusTree.cc
ConsensusNode.cc
GeneSet.cc
VirtualVertex.cc
${CMAKE_CURRENT_BINARY_DIR}/cmdline.c   ${CMAKE_CURRENT_BINARY_DIR}/cmdline.h
)


target_link_libraries(${programname_of_this_subdir} prime-phylo prime-phylo-sfile plotter)
install(TARGETS ${programname_of_this_subdir} DESTINATION bin)

else()
  message(STATUS  "Not building primeCT because Boost was not found" )
endif()

=== src/cxx/applications/primeDLRS-esjolund/CMakeLists.txt ===
include(${CMAKE_SOURCE_DIR}/src/cxx/cmake-include.txt)


include_directories( ${MPI_INCLUDE_PATH} )
include_directories( ${MPI_INCLUDE_PATH}/openmpi/ompi/mpi/cxx )

add_executable(${programname_of_this_subdir}
primeDLRS-esjolund.cc
#test_EdgeDiscBDProbs.cc
${CMAKE_CURRENT_BINARY_DIR}/cmdline.c   ${CMAKE_CURRENT_BINARY_DIR}/cmdline.h
)

set_target_properties(prime-phylo PROPERTIES LINK_FLAGS "${MPI_LINK_FLAGS}" )
set_source_files_properties(MpiMCMC.cxx PROPERTIES COMPILE_FLAGS "${MPI_COMPILE_FLAGS}")

target_link_libraries(${programname_of_this_subdir} prime-phylo prime-phylo-sfile ${Boost_LIBRARIES} )

install(TARGETS ${programname_of_this_subdir} DESTINATION bin)

=== src/cxx/applications/primeDLRS/CMakeLists.txt ===
include(${CMAKE_SOURCE_DIR}/src/cxx/cmake-include.txt)

conf_value_from_cmake(primeDLRS Iterations 1000000) # Used in man-page, C++ code. See macro definition in trunk/cmake/macro.cmake
conf_value_from_cmake(primeDLRS Thinning 100)
conf_value_from_cmake(primeDLRS PrintFactor 1)
conf_value_from_cmake(primeDLRS DiscTimestep 0.05)
conf_value_from_cmake(primeDLRS DiscMinIvs 3)
conf_value_from_cmake(primeDLRS SiteRateCats 1)
conf_value_from_cmake(primeDLRS BDRates_first 1.0)
conf_value_from_cmake(primeDLRS BDRates_second 1.0)
conf_value_from_cmake(primeDLRS RunType MCMC)
conf_value_from_cmake(primeDLRS SubstModel JTT)
conf_value_from_cmake(primeDLRS EdgeRateDistr Gamma)

configure_file(primeDLRS.1.cmake ${tmp_man_pages_dir}/primeDLRS.1 @ONLY)

#configure_file(config_primeDLRS.hh.cmake ${CMAKE_CURRENT_BINARY_DIR}/config_primeDLRS.hh)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(${programname_of_this_subdir}
primeDLRS.cc
#test_EdgeDiscBDProbs.cc
)
# set_property(TARGET ${programname_of_this_subdir} PROPERTY LINK_SEARCH_END_STATIC ON )
target_link_libraries(${programname_of_this_subdir} prime-phylo prime-phylo-sfile)

prime_add_tests(${CMAKE_CURRENT_SOURCE_DIR}/tests)

install(TARGETS ${programname_of_this_subdir} DESTINATION bin)

=== src/cxx/applications/primeDTLSR/CMakeLists.txt ===
include(${CMAKE_SOURCE_DIR}/src/cxx/cmake-include.txt)

conf_value_from_cmake(primeDTLSR Iterations 1000000) # Used in man-page, C++ code. See macro definition in trunk/cmake/macro.cmake
conf_value_from_cmake(primeDTLSR Thinning 100)
conf_value_from_cmake(primeDTLSR PrintFactor 1)
conf_value_from_cmake(primeDTLSR DiscTimestep 0.05)
conf_value_from_cmake(primeDTLSR DiscMinIvs 3)
conf_value_from_cmake(primeDTLSR SiteRateCats 1)
conf_value_from_cmake(primeDTLSR BirthDeathTransfer_first 0.1)
conf_value_from_cmake(primeDTLSR BirthDeathTransfer_second 0.1)
conf_value_from_cmake(primeDTLSR BirthDeathTransfer_third 0.1)
conf_value_from_cmake(primeDTLSR TransferCounts 0)
conf_value_from_cmake(primeDTLSR EdgeRateParams_first 1.0)
conf_value_from_cmake(primeDTLSR EdgeRateParams_second 1.0)
conf_value_from_cmake(primeDTLSR RunType MCMC)
conf_value_from_cmake(primeDTLSR SubstModel JTT)
conf_value_from_cmake(primeDTLSR EdgeRateDistr Gamma)

configure_file(primeDTLSR.1.cmake ${tmp_man_pages_dir}/primeDTLSR.1 @ONLY)

include_directories(${CMAKE_CURRENT_BINARY_DIR})


add_executable(${programname_of_this_subdir}
idolatrous.cc
)

target_link_libraries(${programname_of_this_subdir} prime-phylo prime-phylo-sfile)

prime_add_tests(${CMAKE_CURRENT_SOURCE_DIR}/tests)

install(TARGETS ${programname_of_this_subdir} DESTINATION bin)

=== src/cxx/applications/primeDUP/CMakeLists.txt ===
include(${CMAKE_SOURCE_DIR}/src/cxx/cmake-include.txt)

add_executable(${programname_of_this_subdir}
primeDUP.cc 
${CMAKE_CURRENT_BINARY_DIR}/cmdline.c   
${CMAKE_CURRENT_BINARY_DIR}/cmdline.h
)

target_link_libraries(${programname_of_this_subdir} prime-phylo prime-phylo-sfile )

install(TARGETS ${programname_of_this_subdir} DESTINATION bin)

=== src/cxx/applications/primeGEM/CMakeLists.txt ===
include(${CMAKE_SOURCE_DIR}/src/cxx/cmake-include.txt)


# ifeq ($(shell uname),Darwin)
#	MY_LDFLAGS =	-framework accelerate -bind_at_load 

add_executable(${programname_of_this_subdir}
troyo.cc
${CMAKE_CURRENT_BINARY_DIR}/cmdline.c   ${CMAKE_CURRENT_BINARY_DIR}/cmdline.h 
)

configure_file(primeGEM.1.cmake ${tmp_man_pages_dir}/primeGEM.1 @ONLY)

target_link_libraries(${programname_of_this_subdir} prime-phylo)

install(TARGETS ${programname_of_this_subdir} DESTINATION bin)




# troyo_gengetopt.cc is a fork of troyo.cc
# troyo_gengetopt.cc is meant to use gengetopt instead of the function readOptions()


if(NOT official_binary_packaging) 
add_executable(primeGEM_gengetopt
troyo_gengetopt.cc
${CMAKE_CURRENT_BINARY_DIR}/cmdline.c   ${CMAKE_CURRENT_BINARY_DIR}/cmdline.h 
)
target_link_libraries(primeGEM_gengetopt prime-phylo )
install(TARGETS primeGEM_gengetopt DESTINATION bin)
endif()

=== src/cxx/applications/primeGEM/Makefile ===
LEX = flex
YACC = bison
CC = gcc
CXX = g++
RANLIB = ranlib

VERSION=0.1
RELEASE_ARCHIVE=primeGEM_v$(VERSION).tgz

# Options for flex and bison:
#    Yacc/bison: -d - Write a definition file .h
#                -y - Behave like yacc and write output to y.tab.c. Make's 
#                     implicit rules then mv:s to the proper .c file.
#    Lex/flex:   No options needed, it seems.
YFLAGS = -d -y -p yytree_
LFLAGS = -Pyytree_

DEBUG_DEFS=#-g
OPTIMIZATION=-O3 -funroll-loops -DNDEBUG 
CPPFLAGS=$(OPTIMIZATION) $(DEBUG_DEFS) -Wreorder #-Wall

ifeq ($(shell uname),Darwin)
	MY_LDFLAGS =	-framework accelerate -bind_at_load 
else
	MY_LDFLAGS =	$(LA_LINK) $(SFILE_LINK) #-I/usr/include/ 
endif

TREE=	BranchSwapping.o Node.o Tree.o 
IO=	NHX.o NHXparse.o NHXnode.o NHXtree.o NHXannotation.o 
MCMC=	MCMCModel.o MCMCObject.o SimpleML.o SimpleMCMC.o StdMCMCModel.o 
AUX=	AnError.o Beep.o Density2P_common.o Density2P_positive.o \
	DiscreteGamma.o GammaDensity.o LogNormDensity.o NodeMap.o \
	NodeNodeMap.o NormalDensity.o PerturbationObservable.o PRNG.o \
	Probability.o SetOfNodes.o TreeAnalysis.o TreeIO.o TreeIOTraits.o \
	TreePerturbationEvent.o UniformDensity.o 


OBJS=	troyo.o BirthDeathMCMC.o BirthDeathProbs.o DummyMCMC.o Hacks.o \
	GammaMap.o GuestTreeModel.o InvMRCA.o LambdaMap.o ProbabilityModel.o \
	ReconciliationModel.o StrStrMap.o TopTimeMCMC.o TreeMCMC.o \
	$(IO) $(AUX) $(MCMC) $(TREE)

all: primeGEM

primeGEM: troyo.o $(OBJS) 
	$(CXX) $(CPPFLAGS) -o $@ $^ $(MY_LDFLAGS)


#
# Bundle it up!
#
release: 
release: 
	make clean
	rm -rf /tmp/primeGEM_v$(VERSION)
	mkdir /tmp/primeGEM_v$(VERSION)
	cp `ls|grep -v www|grep -v doc|grep -v tgz|grep -v primeGEM|grep -v \~` /tmp/primeGEM_v$(VERSION)
	cd /tmp; tar -czhf $(RELEASE_ARCHIVE) primeGEM_v$(VERSION)/*
	mv /tmp/$(RELEASE_ARCHIVE) .; #gzip $(RELEASE_ARCHIVE)
	rm -r /tmp/primeGEM_v$(VERSION)
	@echo
	@echo "*** A gzipped tar file is now available! ***"
	@echo

################################################
#
# Important dependencies and special rules
#

NHXparse.h: NHXparse.c NHXparse.y
	$(YACC) $(YFLAGS) NHXparse.y
	mv y.tab.h $@

NHX.l: NHXparse.y NHXparse.h

NHXparse.o: NHXparse.y NHXparse.h


################################################

clean:
	$(RM) *.o y.tab.c NHX.c NHXparse.[ch] troyo

=== src/cxx/applications/primeGEMrec/CMakeLists.txt ===
include(${CMAKE_SOURCE_DIR}/src/cxx/cmake-include.txt)


# ifeq ($(shell uname),Darwin)
#	MY_LDFLAGS =	-framework accelerate -bind_at_load 


add_executable(${programname_of_this_subdir}
primeGEMrec.cc
${CMAKE_CURRENT_BINARY_DIR}/cmdline.c   ${CMAKE_CURRENT_BINARY_DIR}/cmdline.h 
)


target_link_libraries(${programname_of_this_subdir} prime-phylo)

install(TARGETS ${programname_of_this_subdir} DESTINATION bin)




# troyo_gengetopt.cc is a fork of troyo.cc
# troyo_gengetopt.cc is meant to use gengetopt instead of the function readOptions()



#add_executable(primeGEM_gengetopt
#troyo_gengetopt.cc
#${CMAKE_CURRENT_BINARY_DIR}/cmdline.c   ${CMAKE_CURRENT_BINARY_DIR}/cmdline.h 
#)

#target_link_libraries(primeGEM_gengetopt prime )
#install(TARGETS primeGEM_gengetopt DESTINATION bin)

=== debian/changelog ===
prime-phylo (1.0.11-4build2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:39:12 +0000

prime-phylo (1.0.11-4build1) zesty; urgency=medium

  * No-change rebuild against libopenmpi2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 22 Oct 2016 01:51:12 +0000

prime-phylo (1.0.11-4) unstable; urgency=medium

  * Team upload.
  * fix FTBFS with Boost 1.60 (Closes: #833334)
    Thanks to Graham Inggs for the patch.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 03 Aug 2016 11:20:36 +0000

prime-phylo (1.0.11-3) unstable; urgency=medium

  * Team upload.
  * Fix building with GCC 6 (Closes: #812031)
  * Enable full hardening.
  * Bump Standards-Version.
  * Use secure Vcs-Git.
  * Remove now unused Lintian override.

 -- Sascha Steinbiss <satta@debian.org>  Mon, 25 Jul 2016 21:13:35 +0000

prime-phylo (1.0.11-2) unstable; urgency=medium

  * Add missing Vcs fields.
  * cme fix dpkg-control
  * Move debian/upstream to debian/upstream/metadata

 -- Andreas Tille <tille@debian.org>  Fri, 17 Oct 2014 09:45:42 +0200

prime-phylo (1.0.11-1) unstable; urgency=low

  * Initial release (Closes: #684039)

 -- Erik Sjolund <erik.sjolund@gmail.com>  Mon, 17 Dec 2012 14:11:13 +0100

=== debian/control ===
Source: prime-phylo
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Erik Sjolund <erik.sjolund@gmail.com>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9.0.0),
               gengetopt,
               cmake,
               libblas-dev,
               liblapack-dev,
               gfortran,
               bison,
               flex,
               libopenmpi-dev,
               libxml2-dev,
               libboost-dev,
               libboost-mpi-dev,
               libboost-serialization-dev,
               zlib1g-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/prime-phylo.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/prime-phylo.git
Homepage: http://prime.sbc.su.se

Package: prime-phylo
Architecture: any
Depends: ${perl:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: njplot,
          treeviewx,
          muscle,
          probalign,
          mafft,
          python-biopython,
          mrbayes,
          phyml,
          raxml
Description: bayesian estimation of gene trees taking the species tree into account
 PrIME (Probabilistic Integrated Models of Evolution) is a package
 supporting inference of evolutionary parameters in a Bayesian framework
 using Markov chain Monte Carlo simulation. A distinguishing feature of
 PrIME is that the species tree is taken into account when analyzing gene
 trees.
 .
 The input data to PrIME is a multiple sequence alignment in FASTA format
 and the output data contains trees in Newick format.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#DPKG_EXPORT_BUILDFLAGS = 1
#include /usr/share/dpkg/buildflags.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-Dofficial_binary_packaging=on \
	-Dprime_dynamic=on \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_INSTALL_RPATH=/usr/lib/prime-phylo \
	-DCMAKE_BUILD_TYPE=RELEASE

#override_dh_shlibdeps:
#	dh_shlibdeps -l/usr/lib/prime-phylo

override_dh_makeshlibs:
	dh_makeshlibs -pprime-phylo -Xprime-phylo.so -Xprime-phylo-sfile.so

=== debian/watch ===
version=3

http://prime.sbc.su.se/download/prime-phylo-(.*)\.tar\.gz
